#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#include <stack>
#include <queue>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

const int INF_INF = 1e9 + 10;
const ll LL_INF = 1e18 + 10;
const ld PI = acos(-1);

int main() {
	ll n, p;
	cin >> n >> p;
	vector<ll> z(n), a(n), b(n);
	for (int i = 0; i < n; i++) {
		cin >> z[i] >> a[i] >> b[i];
	}
	ll L = 0, R = 1e10;
	while (R - L > 1) {
		ll M = (L + R) / 2;
		ll sum = 0;
		for (int i = 0; i < n; i++) {
			if (M <= z[i]) {
				sum += a[i] * M;
			}
			else {
				sum += a[i] * z[i] + b[i] * (M - z[i]);
			}
		}
		if (sum < p) {
			L = M;
		}
		else {
			R = M;
		}
	}
	cout << R;
}
