#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#include <stack>
#include <queue>
#include <cassert>
#include <algorithm>
#include <cmath>

using namespace std;
using ll = long long;
using ld = long double;

const int INF_INF = 1e9 + 10;
const ll LL_INF = 1e18 + 10;
const ld PI = acos(-1);

const int MOD = 1e9 + 7;

int sum(int a, int b) {
	if (a + b >= MOD) {
		return a + b - MOD;
	}
	return a + b;
}

vector<int> a;
int n, m;

int short_solve(vector<int> s) {
	int res = 0;
	if (s.size() == n) {
		return 1;
	}
	for (int i = 0; i < m; i++) {
		bool able = true;
		for (int j = s.size() - 1; j >= 0 && (int)s.size() - j < a[i] && able; j--) {
			if (s[j] == a[i]) {
				able = false;
			}
		}
		if (able) {
			vector<int> next_s = s;
			next_s.push_back(a[i]);
			res = sum(res, short_solve(next_s));
		}
	}
	return res;
}

int main() {
	const int MAXD = 7;
	cin >> n >> m;
	a.resize(m);
	for (auto& i : a) {
		cin >> i;
	}
	if (n < MAXD) {
		cout << short_solve(vector<int>());
	}
	else {

	}
}
