#include <iostream>
#include <vector>
#include <set>
#include <unordered_map>
#include <map>
#include <stack>
#include <queue>
#include <cassert>
#include <algorithm>
#include <cmath>
#include <string>

#pragma GCC optimize("O3,unroll-loops")

using namespace std;
using ll = long long;
using ld = long double;

const int INF_INF = 1e9 + 10;
const ll LL_INF = 1e18 + 10;
const ld PI = acos(-1);

const int MOD = 1e9 + 7;

int sum(int a, int b) {
	if (a + b >= MOD) {
		return a + b - MOD;
	}
	return a + b;
}

map<vector<int>, int> cnt;
void calc(vector<int> s, int sum, int last) {
	cnt[s]++;
	if (sum == 12) {
		return;
	}
	for (int c = 0; c < 3; c++) {
		vector<int> next_s = s;
		next_s[last * 3 + c]++;
		calc(next_s, sum + 1, c);
	}
}

int main() {
	int g, q;
	cin >> g >> q;
	if (g == 3) {
		for (int c = 0; c < 3; c++) {
			calc(vector<int>(9, 0), 0, c);
		}
		while (q--) {
			string s;
			cin >> s;
			vector<int> comb_cnt(9, 0);
			for (int i = 0; i < s.size() - 1; i++) {
				comb_cnt[(s[i] - 'a') * 3 + s[i + 1] - 'a']++;
			}
			cout << cnt[comb_cnt] << '\n';
		}
	}
}