#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <deque>

using namespace std;
using ll = long long;
using ld = long double;

const int INT_INF = 1e9 + 10;
const int LL_INF = 1e18 + 10;

int main() {
	int t_num;
	cin >> t_num;
	while (t_num--) {
		ll a, b, k, m;
		cin >> a >> b >> k >> m;
		ll L = -1, R = k + 2;
		while (R - L > 1) {
			ll M = (L + R) / 2;
			if ((k + 2 - M) * M < m) {
				L = M;
			}
			else {
				R = M;
			}
		}
		ll x = R;
		ll y = k + 2 - x;
		if (x > y && y <= a && x <= b) {
			swap(x, y);
		}
		if (x * (k + 2 - x) == m && x <= a && y <= b) {
			cout << x - 1 << ' ' << y - 1 << '\n';
		}
		else {
			cout << "-1\n";
		}
	}
}