﻿#include <iostream>
#include <vector>
#include <cmath>
#include <algorithm>
#include <set>
#include <queue>
#include <stack>
#include <deque>
#include <cassert>

using namespace std;
using ll = long long;
using ld = long double;

const int INT_INF = 1e9 + 10;
const int LL_INF = 1e18 + 10;

vector<ll> fib;

void calc_fib() {
	ll a = 1, b = 1;
	//для больших подгрупп поменять условие
	while (b * b <= 1000000000) {
		ll next = a + b;
		fib.push_back(next);
		a = b;
		b = next;
	}
}

ll solve(int ptr, ll a) {
	if (a == 1) {
		return 1;
	}
	ll cnt = 0;
	for (int i = ptr; i < fib.size(); i++) {
		if (a % fib[i] == 0) {
			cnt += solve(i, a / fib[i]);
		}
	}
	return cnt;
}

int main() {
	calc_fib();
	int t_num;
	cin >> t_num;
	while (t_num--) {
		ll a;
		cin >> a;
		cout << solve(0, a) << '\n';
	}
}